Attribute VB_Name = "Lancement"
' const dfi
Public Const TempPartieChronoTouriste As Long = 60000
Public Const TempPartieChronoBaroudeur As Long = 50000
Public Const TempPartieChronoLoup As Long = 40000
'const IA
Public Const Touriste As Integer = 1
Public Const Baroudeur As Integer = 2
Public Const Loup As Integer = 3
Public Const CTouche As Integer = 98
Public Const DansLo As Integer = 99
Public Const PrecisionChoixIA = 30      'taille du buffer de choix de placement bato
'const diverses
Public Const SANS_VIDAGE = 1
Public Const AVEC_VIDAGE = 0
Public Const NB_PART_MEDAIILE_BRONZE = 5
Public Const NB_PART_MEDAIILE_ARGENT = 10
Public Const NB_PART_MEDAIILE_OR = 18
Public Const NombreSonChat As Integer = 18
Public Const XIco As Integer = 111
Public Const Yico As Integer = 15
Public Const VICTOIRE  As Byte = 1
Public Const DEFAITE As Byte = 0



'>>>>>>>>>> variable jeu >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'------types -----------------------------
    

Type DesCoord
    X As Integer  'coord en abcisse
    Y As Integer 'coord en ordonne
    Sens As Integer 'sens : H ou V
    Poid As Integer 'poid de l'emplacement relatif aux stats joueur
End Type
Type UnJoueur
    Nom As String  'nom du joueur
    Point As Long   'nombre des points
    Icone As Integer  'numro de l'icone
    NbrVictoire As Integer   'nombre de victoire solo
    NbrPartie As Integer      'nombres de parties solo
    NbrPartieRezo As Integer   'Nombre de partie rezo disputes
    NbrVictoireRezo As Integer 'nombre de victoires en rezo
    Medaille(1 To 3) As Boolean 'Medailles aquiise pour chacun des nivo d'IA
    Pn(1 To 3) As Long   'Nombres de parties gagnes pour chaque nivo IA
    TotalJoue As Integer 'nombre de cases joue par le joueur
    TotalCoule As Integer  'nombre de bato couls
    TotalTouche As Integer 'nombre de cases joues
    Stat(1 To 10, 1 To 10) As Integer
End Type
Type MaCase    'type d'une case
    ValJoueur As Byte  'valeur de nos bateaux
    ValAdv As Byte     'valeur des bato de l'adv
End Type
Type UnBato              'type d'un bato
    NombreCases As Byte   'nombre de cases qu'il prend
    NombreTouche As Byte  'nombre de cases touches
    NomBateau As String   'nom du bateau
    X As Integer          'postion pour le sprite
    Y As Integer
    Vert As Boolean        'disposition H ou V
End Type
Type UnBoutton           'type d'un bouton de l'interf
    Dessus As Boolean    'on est dessus avec la souris ?
    Txt As String        'texte de commentaire
    X As Integer         'postion sprite
    Y As Integer
    GotoX As Integer     'position ou il faut aller
    GotoY As Integer
    Xdef As Integer      'position initiale
    Ydef As Integer
    lg As Integer        'longeur
    ht As Integer        'hauteur
    decal As Integer     'de combien on dcale quand on est dessus
    vitesseX As Integer  'vitesse de deplacement en Pix / frame
    vitesseY As Integer
End Type
Type UneBombe            'type d'une bombe
    X As Integer         'coord du sprite
    Y As Integer
    CaseX As Byte        'coord dans la matrice
    CaseY As Byte
    DimActu As Integer   'dimention du sprite
End Type

'sert pour les calculs 3d
Type UnPoint             'un point = une etoile ou tete de mort
  Xdep As Integer        'cood avant calcul de rotation
  YDep As Integer
  X As Integer           'coord d'affichage
  Y As Integer
  angle As Integer       'decalage en angle
End Type
Type UnTir
    X As Integer        'coord du tir
    Y As Integer
End Type

'-------- variables simples --------------
Public Connecte As Boolean       'indique si on esr connect ou pas
Public ModeJeu As String  ' indique si "solo" ou "rezo"
Public Equipe As String     'obsolete mais utilis en interne
Public MouseY, MouseX, Bouton As Integer  'coord de la souris
Public CaseX As Integer, CaseY As Integer
Public ExCaseX, ExCaseY As Integer      'coord antrieure de la souris
Public TailleCurseur As Integer   'largueur du curseur carr rouge
Public SensICase As Integer     'indicateur de grossisement du cadre rouge -1 ou 1
Public Xrezo, Yrezo As Integer   'coord de l'adv dans les parties rezo
Public i As Integer, j As Long, X As Integer, Y As Integer, k As Integer
Public GotoBouton As Integer  'indique ou le bouton doit aller
Public ActuBouton As Integer   'position actuelle du bouton
Public Commentaire  As String  'string de commentaires
Public Hasard As Integer     'valeur tire au hasard
Public BatoAPlacer  As Byte    'num du bato a aplacer
Public NivoIA As Byte        'Nivo de l'Intelligence artificielle
Public SonChatAJouer As Integer  'numro du son chat a jouer
'--------- variables du fichier INI --------

Public CheminSons As String      'chemin des fichiers son
Public CheminBMP As String      'chemin des images
Public CheminProfil As String     'Chemin des profils joueurs
Public CheminMusique As String     'chemin des musiques
Public CheminParoles As String   'chemin du dossier des commentaire chat
Public NumMusique As Byte
Public VolumeMusique As Long
Public VolumeFx As Long
Public NomOrdi As String    'nom de l'ordinateur a se connecter
Public ResolutionX As Integer
Public ResolutionY As Integer
Public ProfondeurCouleur As Integer
Public ActiveCompression As Boolean
'--------- STATS #-----------


Public joueur As UnJoueur
Public Ordi As UnJoueur
Public JoueurRezo As UnJoueur
Public TpsDebutPartie As Long
'--------- fin de partie----------
Public QuitterFinal As Boolean
'----------booleen -----------------
Public MonTour As Boolean            'si c montour=true sinon false
Public Quitter As Boolean            'demande de quitter
Public Placement As Boolean          'on est dans l'ecran placement
Public PlacementH As Boolean         'si vrai bato plac en H sinon en V
Public PlacementOk As Boolean        'si le placement est valide
Public Gagne As Boolean
Public RecuNombre As Boolean
Public TirOk As Boolean
Public AniBombe As Boolean
Public TourOk As Boolean
Public EnTraindeJouer As Boolean
Public BatoAdvPlace As Boolean
Public AffAttenteRezo As Boolean
Public FiniAnim As Boolean
Public Touche As Boolean
Public EnvoiFini As Boolean
'-------- Tir -------------------------
Public TirX As Integer
Public TirY As Integer
Public TirXAdv As Integer
Public TirYAdv As Integer
Public AffichTir As Boolean
'------- gestion des temps -------------
Public Temp As Long
Public TempTir, TempTir2 As Long
Public TempCase As Long
Public PartieFinie As Boolean
Public TempBombe As Long
Public TempDrapo As Long
'-------- reseau ------------------------
Public Rejouer As Integer
Public MoiRejouer As Integer
'------- interface ---------------------
Public MessageAffiche As Boolean
Public NombreBouton As Integer
Public Interface As Boolean
Public QuitterInterf As Boolean
Public BouleX As Integer
Public GotoBoule As Integer
Public GotoIco As Integer
Public ActuIco As Integer
Public VitesseIco As Integer
Public GotoDesc As Integer
Public ActuDesc As Integer
Public VitesseDesc As Integer
Public BouleDef As Integer
Public VitesseBoule As Integer
Public CadreY As Integer
Public GotoCadreY As Integer
Public VitesseCadre As Integer
Public NouvellePartie As Boolean
Public Credit As Boolean
Public MultiJoueur As Boolean
Public CreerPartie As Boolean
Public StatutRezo As String
Public Deconnecte As Boolean
Public PartieCree As Boolean
Public JoindrePartie As Boolean
Public ClientInitialis As Boolean
Public Configuration As Boolean
Public ConfigJoueur As Boolean
Public ConfigSon As Boolean
Public ConfigGraph As Boolean
Public Defi As Boolean
Public DebutCredit As Integer
Public TpsCredit As Long
Public AllerdansInterf As Boolean
Public DemandeQuitterPartie As Boolean
Public StatutProfil As String
Public NomTape As String
Public InfoJoueur As String
Public TxtChat As String
Public Chat(1 To 4) As String
Public NumSon As Integer
Public PourcM As Byte
Public PourcF As Byte
Public AvantOui As String
Public EnFinDePartie As Boolean
Public DansPlato As Boolean

'---------- chat ---------------------
Public IcoChat As Integer
Public SonChatJoue As Boolean
Public DeroulIcon As Boolean
Public exIcon As Byte
'--------- Partie Chronomtre----------
Public ChronoBateau As Byte
Public TempPartie As Long
Public TempRestant As Long
Public Chrono As Long
Public PartieChrono As Boolean
Public AccesDefi(1 To 3)  As Integer
Public NivoDefi As Byte

'------- intelligence artificielle -----
Public Trame(1 To 10, 1 To 10) As Integer
Public SurfTrame As Integer
Public SurfTrameBato As Integer
Public LgBatoMin As Integer      'longueur minimale du bateau ennemi depart=2
Public MailleTrame As Integer    'taille de la trame depart =2
Public DepTrame As Integer       'abcisse de depart de la trame
Public NombreProchainTir As Byte
Public MProchainTir(1 To 4) As UnTir
'---------tableaux -----------------------
Public M(0 To 11, 0 To 11) As MaCase
Public bato(1 To 5) As UnBato
Public BatoE(1 To 5) As UnBato
Public Boutton(1 To 30) As UnBoutton
Public Bombe As UneBombe
Public INFO(1 To 4) As String

'-------- API -----------
Public Declare Function AddFontResource Lib "gdi32" Alias "AddFontResourceA" (ByVal lpFileName As String) As Long
Public Declare Function timeGetTime Lib "winmm.dll" () As Long
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

'Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
'Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
    
Public Sub Log(Monmessage As String)
    console.List1.AddItem (Monmessage)
    Debug.Print Monmessage
End Sub

Public Sub init_jeu()
Call Log("INITATLISATION")
    
''''''matrice des bateaux'''''''''''''''''''''''''''''''''''''''''''
    With bato(1)
    .NomBateau = "Porte-Avion"
    .NombreCases = 5
    .NombreTouche = 0
    .X = 610
    .Y = 150
    .Vert = False
    End With
    With bato(2)
    .NomBateau = "Destroyer"
    .NombreCases = 4
    .NombreTouche = 0
    .X = 640
    .Y = 220
    .Vert = False
    End With
    With bato(3)
    .NomBateau = "Croiseur 1"
    .NombreCases = 3
    .NombreTouche = 0
    .X = 677
    .Y = 290
    .Vert = False
    End With
    With bato(4)
    .NomBateau = "Croiseur 2"
    .NombreCases = 3
    .NombreTouche = 0
    .X = 677
    .Y = 360
    .Vert = False
    End With
    With bato(5)
    .NomBateau = "Frgate"
    .NombreCases = 2
    .NombreTouche = 0
    .X = 714
    .Y = 430
    .Vert = False
    End With
    '-------------------------------
        With BatoE(1)
    .NomBateau = "Porte-Avion"
    .NombreCases = 5
    .NombreTouche = 0
    End With
    With BatoE(2)
    .NomBateau = "Destroyer"
    .NombreCases = 4
    .NombreTouche = 0
    End With
    With BatoE(3)
    .NomBateau = "Croiseur 1"
    .NombreCases = 3
    .NombreTouche = 0
    End With
    With BatoE(4)
    .NomBateau = "Croiseur 2"
    .NombreCases = 3
    .NombreTouche = 0

    End With
    With BatoE(5)
    .NomBateau = "Frgate"
    .NombreCases = 2
    .NombreTouche = 0
    End With
    
    For i = 0 To 11
        For j = 0 To 11
        M(i, j).ValJoueur = 0
        M(i, j).ValAdv = 0
        Next
    Next
    Connecte = False
    console.Label1 = " Non connecte"
    ModeJeu = "solo"
    Boutton(5).Txt = " cliquez ici pour quitter"
    Placement = False
    BatoAPlacer = 1
    PlavecementH = True
    Commentaire = "Placez vos bateaux !"
    Randomize
    Hasard = Int((99 * Rnd) + 1)
    Gagne = False
    RecuNombre = False
    joueur.TotalTouche = 0
    joueur.TotalCoule = 0
    joueur.TotalJoue = 0
    Ordi.TotalTouche = 0
    Ordi.TotalCoule = 0
    Ordi.TotalJoue = 0
    AniBombe = False
    EnTraindeJouer = False
    BatoAdvPlace = False
    AffAttenteRezo = False
    FiniAnim = False
    TirX = 99
    TirY = 99
    TirXAdv = 99
    TirYAdv = 99
    Xrezo = 5
    Yrezo = 5
    AffichTir = False
    TailleCurseur = 0
    SensICase = 1
    PartieFinie = True
    Quitter = False
    Touche = False
    i = 0
    j = 0
    X = 0
    Y = 0
    k = 0
    GotoBouton = 0
    ActuBouton = 0
    '------------IA    -----------------
    NivoIA = 1
    MailleTrame = 2
    LgBatoMin = 2
    DepTrame = 2
    For i = 1 To 4
        MProchainTir(i).X = 0
        MProchainTir(i).Y = 0
    Next
    Call EtablirTrame(DepTrame, MailleTrame, 0 + NivoIA, AVEC_VIDAGE) 'trame de  2 en partant de la 2nd case
    '------------------------------------
    PartieCree = False
    ClientInitialis = False
    console.Label1 = "aucune partie en cours"
    AccesDefi(1) = NB_PART_MEDAIILE_BRONZE
    AccesDefi(2) = NB_PART_MEDAIILE_ARGENT
    AccesDefi(3) = NB_PART_MEDAIILE_OR
    TxtChat = ""
    For i = 1 To 4
        Chat(i) = " "
    Next
    
    'MessageAffiche = False
    DeroulIcon = False
    NumSon = 99
    SonChatAJouer = 0
    EnFinDePartie = False

    Rejouer = 0
End Sub
Public Function DdRect(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As RECT
  DdRect.Left = X1
  DdRect.Right = X2
  DdRect.Top = Y1
  DdRect.Bottom = Y2
End Function
Public Function ExisteProfil(nomj As String)
On Local Error GoTo errout
    Open App.Path + CheminProfil + nomj + ".mpj" For Input As #1
    Close #1
    ExisteProfil = True
    Exit Function
errout:
    ExisteProfil = False
    Call Log("profil inexistant " + nomj)
End Function
Public Sub ChargeProfil(nomj As String)
On Local Error GoTo errout
Call Log("charge profil")
nomj = LCase(nomj)
Open App.Path + CheminProfil + nomj + ".mpj" For Binary Access Read As #1
    With joueur
        Get #1, , .Nom
        Get #1, , .Icone
        Get #1, , .NbrPartie
        Get #1, , .NbrPartieRezo
        Get #1, , .NbrVictoire
        Get #1, , .NbrVictoireRezo
        Get #1, , .Point
        Get #1, , .Medaille(1)
        Get #1, , .Medaille(2)
        Get #1, , .Medaille(3)
        Get #1, , .Pn(1)
        Get #1, , .Pn(2)
        Get #1, , .Pn(3)
        For i = 1 To 10
            For j = 1 To 10
                Get #1, , .Stat(i, j)
            Next
        Next
    End With
Close #1
GotoIco = joueur.Icone * 70
GotoDesc = joueur.Icone * 123
StatutProfil = "Profil charg " + nomj


If joueur.Icone > 10 Then marocanar.TermApp
Exit Sub
errout:
    Call Log(App.Path + CheminProfil + nomj + ".mpj")
    SauveConsole
    End
End Sub

Public Sub CreeProfil(nomj As String)
    joueur.Nom = nomj
    joueur.Icone = 9
    joueur.NbrPartie = 0
    joueur.NbrPartieRezo = 0
    joueur.NbrVictoire = 0
    joueur.NbrVictoireRezo = 0
    joueur.Point = 1
    joueur.Medaille(1) = False
    joueur.Medaille(2) = False
    joueur.Medaille(3) = False
    joueur.Pn(1) = 0
    joueur.Pn(2) = 0
    joueur.Pn(3) = 0
    For i = 1 To 10
        For j = 1 To 10
            joueur.Stat(i, j) = 0
        Next
    Next
    Call Log("profil cree " + nomj)
    SauveProfil (joueur.Nom)
    
End Sub
Public Sub SauveProfil(nomj As String)
joueur.Nom = nomj
nomj = LCase(nomj)

'####TEMP####
'joueur.Medaille(1) = False
'####/temp###
Call Log("SauveProfil " + nomj)
Open App.Path + CheminProfil + nomj + ".mpj" For Binary Access Write As #1
    With joueur
        Put #1, , .Nom
        Put #1, , .Icone
        Put #1, , .NbrPartie
        Put #1, , .NbrPartieRezo
        Put #1, , .NbrVictoire
        Put #1, , .NbrVictoireRezo
        Put #1, , .Point
        Put #1, , .Medaille(1)
        Put #1, , .Medaille(2)
        Put #1, , .Medaille(3)
        Put #1, , .Pn(1)
        Put #1, , .Pn(2)
        Put #1, , .Pn(3)
        For i = 1 To 10
            For j = 1 To 10
                Put #1, , .Stat(i, j)
            Next
        Next
    End With
Close #1
'        call log( joueur.Nom)
'        call log( Str(joueur.Icone))
'        call log( Str(joueur.NbrPartie))
'        call log( Str(joueur.NbrPartieRezo))
'        call log( Str(joueur.NbrVictoire))
'        call log( Str(joueur.NbrVictoireRezo))
'        call log( Str(joueur.Point))
'        call log( Str(joueur.Medaille(1)))
'        call log( Str(joueur.Medaille(2)))
'        call log( Str(joueur.Medaille(3)))
'        call log( Str(joueur.Pn(1)))
'        call log( Str(joueur.Pn(2)))
'        call log( Str(joueur.Pn(3)))
        Call Log("SauvProfil " + nomj)
    StatutProfil = "Profil sauvegard " + nomj
End Sub
Public Sub SauveConsole()
Open App.Path + "\CONSOLE.TXT" For Output As #1
For i = 0 To console.List1.ListCount
    Write #1, console.List1.List(i)
Next
Close #1
End Sub
Public Sub SauveVariables()
Open App.Path + "\config.ini" For Output As #1
    Write #1, NomOrdi
    Write #1, NivoIA
    Write #1, CheminSons
    Write #1, CheminBMP
    Write #1, CheminProfil
    Write #1, CheminMusique
    Write #1, CheminParoles
    Write #1, joueur.Nom
    Write #1, ResolutionX
    Write #1, ResolutionY
    Write #1, ProfondeurCouleur
    Write #1, VolumeMusique
    Write #1, VolumeFx
    Write #1, NumMusique
    Write #1, ActiveCompression
Close #1
    SauveProfil (joueur.Nom)
End Sub
Public Sub ChargerDonnees()
Open App.Path + "\config.ini" For Input As #1
    Input #1, NomOrdi
    Input #1, NivoIA
    Input #1, CheminSons
    Input #1, CheminBMP
    Input #1, CheminProfil
    Input #1, CheminMusique
    Input #1, CheminParoles
    Input #1, joueur.Nom
    Input #1, ResolutionX
    Input #1, ResolutionY
    Input #1, ProfondeurCouleur
    Input #1, VolumeMusique
    Input #1, VolumeFx
    Input #1, NumMusique
    Input #1, ActiveCompression
Close #1
Debug.Print "donnee de config.ini charges"
End Sub
Public Sub Main()
    Debug.Print "Chargement Console"
    ChDrive (App.Path)
    Debug.Print Environ$("windir")
    Call AddFontResource(App.Path + "\ZEROHOUR.TTF")
    console.Show
    ChargerDonnees
    
    
    If ExisteProfil(joueur.Nom) Then
        ChargeProfil (joueur.Nom)
    Else
        If joueur.Nom = "" Then joueur.Nom = "defaut"
        CreeProfil (joueur.Nom)
        ChargeProfil (joueur.Nom)
    End If
    Connecte = False

    Call Log("Decompression des musiques")
   If ActiveCompression Then
        marocanar.Init_PreChargeSon
    Else
        'intro.Show
       marocanar.Show
    End If
End Sub
